require 'mahoujin/atoms/choice'
require 'mahoujin/atoms/concatenation'
require 'mahoujin/atoms/exception'
require 'mahoujin/atoms/grouping'
require 'mahoujin/atoms/non_terminal'
require 'mahoujin/atoms/optional'
require 'mahoujin/atoms/prose'
require 'mahoujin/atoms/rule_name'
require 'mahoujin/atoms/rule'
require 'mahoujin/atoms/specific_repetition'
require 'mahoujin/atoms/syntax'
require 'mahoujin/atoms/terminal'
require 'mahoujin/atoms/zero_or_more_repetition'

module Mahoujin
  module Atoms
    constants.each do |constant_name|
      constant = const_get(constant_name)
      next unless constant.is_a?(Class)

      constant.class_exec do
        def self.underscore_name
          name.split('::').last.gsub(/([a-z])([A-Z])/, '\1_\2').downcase
        end

        def bbox
          @bbox ||= Graphics::Utilities::Rectangle.new
        end
      end
    end
  end
end
