module Mahoujin
  module Graphics
    module Styles
      class Basic
        attr_reader :basic

        def initialize
          initialize_basic
          initialize_atoms
        end

        def query(atom, attribute)
          @atoms.fetch(atom).fetch(attribute)
        end

        private

        def initialize_basic
          @basic = {}
          @basic[:font]  = { family: 'serif', size: 12 }.freeze
          @basic[:line]  = { width: 1 }.freeze

          @basic[:unit] = nil
          @basic[:corner] = { radius: 0.618 }.freeze
        end

        def initialize_atoms
          @atoms = {}

          @atoms[Atoms::Terminal]    = { bsize: { width: 2 * 0.618, height: 1 + 2 * 0.618 }.freeze, font: {              }.freeze, background: '#FFFFFF' }
          @atoms[Atoms::NonTerminal] = { bsize: { width: 2 * 0.618, height: 1 + 2 * 0.618 }.freeze, font: {   bold: true }.freeze, background: '#FFFFFF' }
          @atoms[Atoms::Prose]       = { bsize: { width: 2 * 0.618, height: 1 + 2 * 0.618 }.freeze, font: { italic: true }.freeze, background: '#FFFFFF' }
          @atoms[Atoms::Exception]   = { bsize: { width: 2 * 0.618, height: 1 + 2 * 0.618 }.freeze, font: { italic: true }.freeze, background: '#FFFFFF' }
          @atoms[Atoms::RuleName]    = { bsize: { width: 0        , height: 1             }.freeze, font: {   bold: true }.freeze }

          @atoms[Atoms::ZeroOrMoreRepetition] = { padding: { top: 2, bottom: 2, left: 3, right: 3 }.freeze }
          @atoms[Atoms::Optional]             = { padding: {         bottom: 2, left: 2, right: 2 }.freeze }
          @atoms[Atoms::SpecificRepetition]   = { padding: { top: 2,            left: 1, right: 1 }.freeze }

          @atoms[Atoms::Concatenation] = { space: 1 }
          @atoms[Atoms::Choice]        = { space: 1, padding: {                    left: 2, right: 2 }.freeze }
          @atoms[Atoms::Rule]          = { space: 2, padding: {                    left: 2, right: 2 }.freeze }
          @atoms[Atoms::Syntax]        = { space: 4, padding: { top: 2, bottom: 2, left: 2, right: 2 }.freeze }
        end
      end
    end
  end
end
