module Mahoujin
  module Graphics
    module Utilities
      class Rectangle
        attr_accessor :left, :top, :right, :bottom, :centerline

        def initialize(left = 0, top = 0, right = 0, bottom = 0)
          @left, @top, @right, @bottom = left, top, right, bottom
          @centerline = @top + (@bottom - @top).fdiv(2)
        end

        def sync_with(rectangle)
          @left, @top, @right, @bottom = rectangle.left, rectangle.top, rectangle.right, rectangle.bottom
          @centerline = rectangle.centerline
        end

        def width
          @right - @left
        end

        def width=(width)
          @right = @left + width
        end

        def height
          @bottom - @top
        end

        def height=(height)
          @centerline = @top + height * (@centerline - @top).fdiv(@bottom - @top)
          @bottom = @top + height
        end

        def move_left(left)
          @right = left + (@right - @left)
          @left = left
        end

        def move_right(right)
          @left = right + (@left - @right)
          @right = right
        end

        def move_top(top)
          @centerline = top + (@centerline - @top)
          @bottom = top + (@bottom - @top)
          @top = top
        end

        def move_bottom(bottom)
          @centerline = bottom + (@centerline - @bottom)
          @top = bottom + (@top - @bottom)
          @bottom = bottom
        end
      end
    end
  end
end
